----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:58:21 10/26/2009 
-- Design Name: 
-- Module Name:    schiebereg - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity schiebereg8bit is
   Port ( CLOCK_SR : in  STD_LOGIC;       --LVDS Takt
          RESET_SR : in  STD_LOGIC;       --Schieberegister Reset
          DATA_IN_SR : in  STD_LOGIC;     --serielle Daten Eingang
			 FULL : out STD_LOGIC;				--8mal geschiftet, Register voller gltiger Daten
          DATA_OUT_SR : out STD_LOGIC_VECTOR (7 downto 0) --parallele Daten Ausgang
      );
end schiebereg8bit;

architecture Behavioral of schiebereg8bit is

signal AUSGANG : STD_LOGIC_VECTOR (7 downto 0);
signal COUNT_INT : integer range 0 to 7;
signal FULL_INT : STD_LOGIC;

begin

SR_8bit: process (CLOCK_SR, RESET_SR, COUNT_INT)
begin
	if rising_edge(CLOCK_SR) then	
		if (RESET_SR = '1')
			then 	AUSGANG <= (others => '0');
					COUNT_INT <= 0;
			else
				AUSGANG(0) <= DATA_IN_SR;
				AUSGANG(1) <= AUSGANG(0);
				AUSGANG(2) <= AUSGANG(1);
				AUSGANG(3) <= AUSGANG(2);
				AUSGANG(4) <= AUSGANG(3);
				AUSGANG(5) <= AUSGANG(4);
				AUSGANG(6) <= AUSGANG(5);
				AUSGANG(7) <= AUSGANG(6);
				
				if (COUNT_INT < 7)
					then 	COUNT_INT <= COUNT_INT + 1;
							FULL_INT <= '0';
					elsif (COUNT_INT = 7) then
							COUNT_INT <= 0;
							FULL_INT <= '1';
				end if;
		end if;
	end if;	
end process SR_8bit;

FULL <= FULL_INT;
DATA_OUT_SR <= AUSGANG;

end Behavioral;

